
#ifndef _FORM_H_
#define _FORM_H_

#ifndef _FORM_C_
#define _FORM_C_EX_ extern
#else
#define _FORM_C_EX_
#endif

void form_update(HWND hWnd,int mode);
void form_init(HWND hWnd);
void form_contentmenu(HWND hWnd,LPARAM lParam);
void form_loadmenu(HINSTANCE hInstance);
int  form_user_select(HWND hWnd,const char *caption);

_FORM_C_EX_ int select1_type;
_FORM_C_EX_ int select2_type;
_FORM_C_EX_ int cmd_type;

typedef struct {
	int id;
	int count;
	char caption[32];
	char mess[32][256];
} SELECT_DATA;
_FORM_C_EX_ SELECT_DATA form_select;

#define	UPDATE_INFO		0
#define UPDATE_EXTRA	1
#define UPDATE_EXTRA2	2

#define	UPDATE_MESSAGE	10
#define UPDATE_OBJECT	11
#define	UPDATE_PARTY	12
#define	UPDATE_GUILD	13

#define UPDATE_STATUS	20
#define	UPDATE_SKILL	21
#define UPDATE_ITEM		22

#endif
