
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
char* posw2str(char *pos);
char* pos2str(char *pos);

// str Ɋ܂܂s
void nobr(char *str) {
	char *p1 = str;
	char *p2 = str;
	while(*p1) {
		if(*p1 != '\n' && *p1 != '\r') {
			*(p2++) = *(p1++);
		} else {
			p1++;
		}
	}
	*p2 = 0;
}

void long2pos(char *pos,int to) {
	// [xxxxxxxx xxyyyyyy yyyy0000]
	int x,y;
	unsigned char *p = (unsigned char *)pos;
	x = to & 0xFFFF;
	y = to >> 16;
	p[0] = (unsigned char)(x >> 2);
	p[1] = (unsigned char)(((x & 0x03) << 6) | (y >> 4));
	p[2] = (unsigned char)((y & 0x0F) << 4);
}

int long_dis(long a,long b) {
	int dx = abs((a&0xFFFF)-(b&0xFFFF));
	int dy = abs((a>>16)-(b>>16));
	return  (dx > dy ? dx : dy);
}

char* pos2str(char *pos) {
	static char ret[32];
	unsigned char *p = (unsigned char *)pos;
	// [xxxxxxxx xxyyyyyy yyyy0000]
	sprintf(
		ret,
		"(%d,%d)",
		(p[0]        << 2) | (p[1] >> 6),
		((p[1]&0x3F) << 4) | (p[2] >> 4)
	);
	return ret;
}

long pos2long(char *pos) {
	unsigned char *p = (unsigned char *)pos;
	int x = (p[0] << 2)        | (p[1] >> 6);
	int y = ((p[1]&0x3F) << 4) | (p[2] >> 4);
	return (y << 16) | x;
}

char* posw2str(char *pos) {
	// [xxxxxxxx xxyyyyyy yyyyxxxx xxxxxxyy yyyyyyyy]
	static char ret[32];
	unsigned char *p = (unsigned char *)pos;
	sprintf(
		ret,
		"(%d,%d) -> (%d,%d)",
		(p[0] << 2)        | (p[1] >> 6),
		((p[1]&0x3F) << 4) | (p[2] >> 4),
		((p[2]&0x0F) << 6) | (p[3] >> 2),
		((p[3]&0x03) << 8) | p[4]
	);
	return ret;
}

long posw2long(char *pos) {
	unsigned char *p = (unsigned char *)pos;
	int x = ((p[2]&0x0F) << 6) | (p[3] >> 2);
	int y = ((p[3]&0x03) << 8) | p[4];
	return (y << 16) | x;
}

char* long2str(long pos) {
	static char ret[32];
	// [xxxxxxxx xxyyyyyy yyyy0000]
	sprintf(
		ret,
		"%d,%d",
		pos & 0xFFFF,
		pos >> 16
	);
	return ret;
}

long str2pos(char *pos) {
	int x,y;
	x = atoi(pos);
	pos = strchr(pos,',');
	if(pos == NULL) { return -1; }
	y = atoi(pos+1);
	return x | (y << 16);
}

// a <= x <= b ̗Ԃ
int rand2(int a,int b) {
	return rand()*(b - a + 1) / RAND_MAX + a;
}
