#ifndef _ACT_H_
#define _ACT_H_

#include <windows.h>

// ̕G\͉̂H
struct act_data {
	int animes;
	struct act_anime {
		int frames;
		struct act_frame {
			int sprs;
			struct act_spr* spr;
			int sound;
		} *frame;
	} *anime;
	struct spr_data* spr;
};

struct act_data* act_load(struct io_data* io,const wchar_t *file);
void act_free(struct act_data *act);

void act_frame_draw(struct act_data *act,int anime_no,int frame_no,struct vram_data* vram,int pos_x,int pos_y);
void act_size(struct act_data *act,RECT *rect);
void act_anime_size(struct act_data *act,int anime_no,RECT *rect);
void act_frame_size(struct act_data *act,int anime_no,int frame_no,RECT *rect);

void act_check(struct io_data* io,const wchar_t *file,int extra_info);

#endif
