
#ifdef _COMMAND_C_

int login_config(char *id,char *pass,char *host,int *port);

int cmd_login(void) {
	char  buf[1024];
	int  len,port;
	int  pass_len;
	char host[128],id[128],pass[128];
	char *p;
	int  tmp,i;
	PACKET *pk;
	login_config(id,pass,host,&port);
	if(port == 0) { port = 6901; }
	pass_len = strlen(pass);
	sock_debug(0);
	sock_connect(host,port);

	// 0x01DB ÍKey v
	sock_send(0x01DB,NULL,0);
	// 0x01DC ÍKey M
	if(sock_recv(buf,&len,1) != 0x01DC) {
		// ÍKey ȊO
		return 1;
	}

	// MD5 Zo
	{
		char *md5_key = (char *)malloc(len + pass_len + 1);
		memcpy(md5_key,buf,len);
		memcpy(&md5_key[len],pass,pass_len);
		md5_key[len + pass_len] = 0;

		// 0x01DD ID&PASS M
		// 00 : [0a 00 00 00]
		memset(buf,0,45);
		memcpy(buf,"\x0a\x00\x00\x00",4);
		// 04 : account name(24byte)
		strcpy((char *)&buf[4],id);
		// 28 : pass_md5(16byte)
		MD5_binary(md5_key,strlen(md5_key),(char *)&buf[28]);
		free(md5_key);
	}
	// 44 : version2
	buf[44] = 0x03;
	sock_send(0x01DD,buf,0);

	if(sock_recv(&buf,&len,1) != 0x0069) {
		MessageBoxA(NULL,"Login failure","Login Error",MB_OK);
		exit(1); return 0;
	}
	if(len < 75 || (len-43) % 32 != 0) {
		MessageBoxA(NULL,"Login packet Error","Login Error",MB_OK);
		exit(1); return 0;
	}
	chara.login_id1  = p2long(buf,0);
	chara.account_id = p2long(buf,4);
	chara.login_id2  = p2long(buf,8);
	object[0].sex = buf[42];
	printf(
		"login1: %08x login2; %08x account_id: %08x\n",
		chara.login_id1,chara.login_id2
	);

	len -= 43;
	console_outputf("Account_id:%d Sex:%u Servers:%d\n",p2long(buf,4),object[0].sex,len / 32);
	p = (char *)&buf[43];
	console_output("No : IP              PORT LOGIN NAME\n");
	for(i = 0;i< len / 32;i++) {
		console_outputf(
			"% 2u : %-15s % 4u % 5u %s\n",
			i+1,
			sock_long2ip(p2long(p,32*i),host),
			p2short(p,32 * i + 4),
			p2short(p,32 * i + 26),
			&p[6 + 32 * i]
		);
	}
	tmp = console_input_n(1,len / 32) - 1;
	sock_connect(sock_long2ip(p2long(p,32 * tmp),host),p2short(p,32 * tmp + 4));
	memset(&buf,0,16);
	p2long(buf,0) = chara.account_id;
	p2long(buf,4) = chara.login_id1;
	p2long(buf,8) = chara.login_id2;
	buf[14] = object[0].sex;
	sock_send(0x0065,&buf,0);
	// ܂Acound ID ԂĂiȗO₪āEEE
	sock_recv_direct(&buf,4,1);
	if(p2long(buf,0) != chara.account_id) {
		console_outputf(
			"Warning: Account ID response error send:%08u recv:%08u\n",
			chara.account_id,p2long(buf,0)
		);
		exit(1); return 0;
	}
	if(sock_recv(&buf,&len,1) != 0x006B) {
		MessageBoxA(NULL,"Character Data Recv error","Login Error",MB_OK);
		exit(1); return 0;
	}
	if(len < 126 || (len - 20) % 106 != 0) {
		MessageBoxA(NULL,"Character Data Length error","Login Error",MB_OK);
		exit(1); return 0;
	}
	len -= 20;
	//  0                4            8        12          16
	//  <charactor ID>.l <base exp>.l <zeny>.l <job exp>.l <job level>.l
	// 20   28         32        36         40               42     44        46
	// ?.8B <option>.l <karma>.l <manner>.l <status point>.w <HP>.w <MaxHP>.w <SP>.w
	// 48        50        52        54       56          58             60
	// <MaxSP>.w <speed>.w <class>.w <hair>.w <weapon>.2w <base level>.w <skill point>.w
	// 62              64         66                  68                  70
	// <head_bottom>.w <sheild>.w <head option top>.w <head option mid>.w <hair color>.w
	// 72  74         98      99      100     101     102     103     104
	// ?.w <name>.24B <STR>.B <AGI>.B <VIT>.B <INT>.B <DEX>.B <LUK>.B <charactor number>.B ?.w
	p = &buf[20];
	console_output("No : CID      Name                     Lv Job\n"); 
	for(i = 0;i< len / 106 ; i++) {
		char name[32];
		strncpy(name,&p[74 + 106 * i],24); name[24] = 0;
		console_outputf(
			"% 2u : % 8u %-24s % 2u %s\n",i+1,
			p2long(p,106 * i),name,p2short(p,106 * i + 58),
			cls_name(p2short(p,106 * i + 52))
		);
	}
	tmp = console_input_n(1,len / 106) -1;
	chara.chara_id = p2long(p,106 * tmp);
	strncpy(object[0].chara_name,&p[106 * tmp + 74],24);
	object[0].chara_name[24] = 0;
	object[0].lv = p2short(p,106 * tmp + 58);
	buf[0] = p[106 * tmp + 104];
	sock_send(0x0066,&buf,0);
	if(sock_recv(&buf,NULL,1) != 0x0071) {
		MessageBoxA(NULL,"Chara Select Error","Login Error",MB_OK);
		exit(1); return 0;
	}
	if(chara.chara_id != p2long(buf,0)) {
		console_outputf(
			"Warning: Chara ID response error send:%08u recv:%08u\n",
			chara.chara_id,p2long(buf,0)
		);
	}
	strcpy(chara.mapname,&buf[4]);
	sock_connect(sock_long2ip(p2long(buf,20),host),p2short(buf,24));

	pk = &packet_db[packet_get("wanttoconnection")];
	memset(buf,0,pk->len);
	// sSpacket_db ̏ꍇAǂłǂ̂ɏȂ
	// dvȃf[^ׂăOCłȂꍇB
	p2long(buf,pk->pos[3]) = GetTickCount();
	p2long(buf,pk->pos[0]) = chara.account_id;
	p2long(buf,pk->pos[1]) = chara.chara_id;
	p2long(buf,pk->pos[2]) = chara.login_id1;
	buf[pk->pos[4]] = object[0].sex;
	sock_send(pk->id,&buf,0);
	// ܂AJEgIDԂĂ
	sock_recv_direct(&buf,4,1);
	if(p2long(buf,0) != chara.account_id) {
		console_outputf(
			"Warning: Account ID response error send:%08u recv:%08u\n",
			chara.account_id,p2long(buf,0)
		);
	}
	if(sock_recv(&buf,NULL,1) != 0x0073) {
		MessageBoxA(NULL,"Login Error","Login Error",MB_OK);
		exit(1); return 0;
	}

	{
		console_outputf("Name:%s Pos: %s %s\n",
			object[0].chara_name,chara.mapname,pos2str(buf + 4)
		);
		object[0].pos = pos2long(buf + 4);
	}
	console_output("Login Complete.\n");
	cmd_mapload();

	// get charname request
	// chara_cache[0] 𑀍Lɂ
	pk = &packet_db[packet_get("getcharnamerequest")];
	memset(buf,0,pk->len);
	p2long(buf,pk->pos[0]) = chara.account_id;
	sock_send(pk->id,&buf,0);
	object[0].id  = chara.account_id;
	object_used = 1;
	return 0;
}

int login_config(char *id,char *pass,char *host,int *port) {
	// RtBOǂݍ
	FILE *fp;
	int  i;
	char id_count = 0;
	char line[2024];
	char id_list[32][10];
	char pass_list[32][10];
	memset(id_list,0,sizeof(id_list));
	memset(pass_list,0,sizeof(pass_list));
	*id = 0; *pass = 0; *host = 0; *port = 0;
	console_output("Reading Config ... ");
	if( (fp=fopen("db/config.txt","r"))==NULL ){
		MessageBoxA(NULL,"can't read db/config.txt","Read Config",MB_OK);
		exit(1); return 0;
	}
	while(fgets(line,1020,fp)){
		char *p1,*p2,*p3;
		if(line[0]=='/' && line[1]=='/') {
			continue;
		}

		p1 = line;
		// p1 -> 1ڂ̗vf̍Ō
		while(*p1 && *p1 != ' ' && *p1 != '\t' && *p1 != '\r' && *p1 != '\n') { p1++; }
		if(!*p1 || p1 == line) {
			// Pڂ̗vf
			continue;
		}
		*p1 = 0;

		// p2 -> 2ڂ̗vf̐擪
		p2 = p1 + 1;
		while(*p2 && (*p2 == ' ' || *p2 == '\t' || *p2 == '\r' || *p2 == '\n')) { p2++; }
		if(!*p2) {
			// Qڂ̗vf
			continue;
		}

		// p3 -> 2ڂ̗vf̍Ō
		p3 = p2 + 1;
		while(*p3 && *p3 != ' ' && *p3 != '\t' && *p3 != '\r' && *p3 != '\n') { p3++; }
		if(!p3 || p3 == p2 + 1) {
			// Qڂ̗vf
			continue;
		}
		*p3 = 0;
		if(!memcmp(line,"id",2)) {
			int pos = (line[2] == 0 ? 0 : line[2] - '0');
			strcpy(id_list[pos],p2);
			if(id_count < pos) { id_count = pos; }
		} else if(!memcmp(line,"pass",4)) {
			int pos = (line[4] == 0 ? 0 : line[4] - '0');
			strcpy(pass_list[pos],p2);
		} else if(!strcmp(line,"host")) {
			strcpy(host,p2);
		} else if(!strcmp(line,"port")) {
			*port = atoi(p2);
		}
	}
	fclose(fp);
	console_output("Done.\n");
	if(id_count == 0) {
		i = 0;
	} else {
		console_outputf("No : ID\n");
		for(i = 0;i<id_count + 1;i++) {
			console_outputf("% 2d : %s\n",i + 1,id_list[i]);
		}
		i = console_input_n(1,id_count + 1) - 1;
	}
	strcpy(id,id_list[i]);
	strcpy(pass,pass_list[i]);
	if(*id == 0 || *pass == 0 || *host == 0) {
		sprintf(line,"ݒǂݍ݃G[\nid:%s pass:%s host:%s",id,pass,host);
		MessageBoxA(NULL,line,"Read Config",MB_OK);
		exit(1); return 0;
	}
	return 0;
}

#endif
