
#define _COMMAND_C_
#include "command.h"

#include <stdio.h>
#include "../client.h"
#include "../md5calc.h"
#include "db.h"
#include "form.h"
#include "socket.h"
#include "string.h"
#include "../console.h"

#include "cmd_bot.c"
#include "cmd_send.c"
#include "cmd_recv.c"
#include "cmd_login.c"

// ߂l 0:s 1:ړ 2:UJn
int cmd_skilluse(int skill_index,int target_index) {
	PACKET *pk;
	char buf[256];
	static int pos_flag = 0;
	if(skill_index <= 0) {
		return 0;
	}
	console_outputf("XLgp %04d(%s) : ",skills[skill_index].id,skills[skill_index].name);
	if(chara.sp < skills[skill_index].sp) {
		console_outputf("s : SPs\n");
		return 0;
	}
	switch(skills[skill_index].target_type) {
	case 0:
		// Pasv
		console_outputf("s : Passive Skill\n");
		return 0;
	case 1:
		// G : useskilltoid
		if(target_index == LB_ERR || object[target_index].id == 0) {
			console_outputf("s : Target Not Selected\n");
			return 0;
		} else if(object[target_index].type != OBJ_TYPE_MOB) {
			console_outputf("s : Target Not MOB\n");
			return 0;
		} else if(long_dis(object[0].pos,object[target_index].pos) > skills[skill_index].range) {
			// ˒NG
			console_outputf("s : ˒NG\n");
			cmd_walk2(object[target_index].pos,skills[skill_index].range);
			return 1;
		} else {
			// XL
			PACKET *pk = &packet_db[packet_get("useskilltoid")];
			memset(buf,0,pk->len);
			p2short(buf,pk->pos[0]) = skills[skill_index].lv;	// Skill Lv
			p2short(buf,pk->pos[1]) = skills[skill_index].id;	// Skill Num
			p2long (buf,pk->pos[2]) = object[target_index].id;	// Target ID
			sock_send(pk->id,&buf,0);
			console_outputf("Target: %d Lv:%d\n",object[target_index].id,skills[skill_index].lv);
			return 2;
		}
	case 2:
		// ꏊ useskilltopos
		pk = &packet_db[packet_get("useskilltopos")];
		memset(buf,0,pk->len);
		p2short(buf,pk->pos[0]) = skills[skill_index].lv;	// Skill Lv
		p2short(buf,pk->pos[1]) = skills[skill_index].id;	// Skill Num
		p2short(buf,pk->pos[2]) = (short)(object[0].pos & 0xFFFF);	// Pos X
		p2short(buf,pk->pos[3]) = (short)(object[0].pos >> 16);		// Pos Y
		switch(pos_flag) {
		case 0: p2short(buf,pk->pos[2])+=1; break;
		case 1: p2short(buf,pk->pos[3])+=1; break;
		case 2: p2short(buf,pk->pos[2])-=1; break;
		case 3: p2short(buf,pk->pos[3])-=1; break;
		}
		if(++pos_flag == 4) {
			pos_flag = 0;
		}
		sock_send(pk->id,&buf,0);

		console_outputf("Target: pos(%d,%d) Lv:%d\n",(object[0].pos & 0xFFFF) + 1,(object[0].pos >> 16)  + 1,skills[skill_index].lv);
		return 2;
	case 4:
		// 
		pk = &packet_db[packet_get("useskilltoid")];
		memset(buf,0,pk->len);
		p2short(buf,pk->pos[0]) = skills[skill_index].lv;	// Skill Lv
		p2short(buf,pk->pos[1]) = skills[skill_index].id;	// Skill Num
		p2long (buf,pk->pos[2]) = object[0].id;	// Target ID
		sock_send(pk->id,&buf,0);
		console_outputf("Target: %d Lv:%d\n",object[0].id,skills[skill_index].lv);
		return 2;
	case 16:
		//  useskilltoid
		if(target_index == LB_ERR || object[target_index].id == 0) {
			console_outputf("s : Target Not Selected\n");
			return 0;
		} else if(object[target_index].type != OBJ_TYPE_CHR && skills[skill_index].id != 28) {
			// Lpiq[ȊOj
			console_outputf("s : Target Not CHR\n");
			return 0;
		} else if(long_dis(object[0].pos,object[target_index].pos) > skills[skill_index].range) {
			// ˒NG
			console_outputf("s : ˒NG\n");
			cmd_walk2(object[target_index].pos,skills[skill_index].range);
			return 1;
		} else {
			// XL
			PACKET *pk = &packet_db[packet_get("useskilltoid")];
			memset(buf,0,pk->len);
			p2short(buf,pk->pos[0]) = skills[skill_index].lv;	// Skill Lv
			p2short(buf,pk->pos[1]) = skills[skill_index].id;	// Skill Num
			p2long (buf,pk->pos[2]) = object[target_index].id;	// Target ID
			sock_send(pk->id,&buf,0);
			console_outputf("Target: %d Lv:%d\n",object[target_index].id,skills[skill_index].lv);
			return 2;
		}
	default:
		console_outputf("XLgps : Unknown Type\n");
		return 0;
	}
}

// repeat = 0 : P񂾂
// repeat = 1 : AU
// ߂l 0:s 1:ړ 2:UJn
int cmd_attack(int target_index,int repeat) {
	PACKET *pk;
	char buf[256];
	if(target_index <= 0) {
		return 0;
	}
	console_outputf("U : ");
	if(target_index == LB_ERR || object[target_index].id == 0) {
		console_outputf("s : Target Not Selected\n");
		return 0;
	} else if(object[target_index].type != OBJ_TYPE_MOB) {
		console_outputf("s : Target Not MOB\n");
		return 0;
	} else {
		// Us
		if(long_dis(object[0].pos,object[target_index].pos) > chara.attack_range) {
			// U͂Ȃ̂ňړ
			cmd_walk2(object[target_index].pos,chara.attack_range);
			console_outputf("˒OȂ̂ňړ\n");
			return 1;
		} else {
			pk = &packet_db[packet_get("actionrequest")];
			memset(buf,0,pk->len);
			p2long(buf,pk->pos[0]) = object[target_index].id;	// Target ID
			buf[pk->pos[1]] = (repeat ? 0x07 : 0x00);			// Action Type
			sock_send(pk->id,&buf,0);
			console_outputf("send\n");
			return 2;
		}
	}
}

void cmd_mapload(void) {
	char buf[256];
	PACKET *pk;
	// MAPLOAD I
	sock_send(packet_get("loadendack"),NULL,0);

	// tick send
	pk = &packet_db[packet_get("ticksend")];
	memset(buf,0,pk->len);
	p2long(buf,pk->pos[0]) = GetTickCount();
	sock_send(pk->id,&buf,0);
}

void cmd_walk(long to) {
	int  i,flag;
	int  from = object[0].pos;
	char buf[256];
	PACKET *pk;

	// WvIuWFNg炸炷
	do {
		flag = 0;
		if(from == to || to == -1) {
			// Wv̂ňړ
			return;
		}
		for(i=0;i<object_used;i++) {
			if(object[i].id && object[i].pos == to) {
				// POS vW炷
				int dy = (from >> 16) - (to >> 16);
				int dx = (from & 0xFFFF) - (to & 0xFFFF);
				if(abs(dx) > abs(dy)) {
					// x ̕傫 -> x W␳
					if(dx < 0) { to--; } else { to++; }
				} else {
					// y ̕傫 -> y W␳
					if(dy < 0) { to -= 0x10000; } else { to += 0x10000; }
				}
				flag = 1;
				break;
			}
		}
	} while(flag);

	pk = &packet_db[packet_get("walktoxy")];
	memset(buf,0,pk->len);
	long2pos(&buf[pk->pos[0]],to);
	sock_send(pk->id,&buf,0);
}

// to dis ꂽʒuɈړ
// dis ߂̂ȂړȂ
void cmd_walk2(long to,int dis) {
	int from = object[0].pos;
	if(long_dis(from,to)  > dis) {
		while(dis-- > 0) {
			int dy = (from >> 16) - (to >> 16);
			int dx = (from & 0xFFFF) - (to & 0xFFFF);
			if(abs(dx) == abs(dy)) {
				// x ,y W̍ -> ␳
				if(dx < 0) { to--; } else { to++; }
				if(dy < 0) { to -= 0x10000; } else { to += 0x10000; }
			} else if(abs(dx) > abs(dy)) {
				// x ̕傫 -> x W␳
				if(dx < 0) { to--; } else { to++; }
			} else {
				// y ̕傫 -> y W␳
				if(dy < 0) { to -= 0x10000; } else { to += 0x10000; }
			}
		}
		cmd_walk(to);
	}
}

void cmd_quit(void) {
	char buf[256];
	PACKET *pk = &packet_db[packet_get("quitgame")];
	memset(buf,0,pk->len);
	sock_send(pk->id,&buf,0);
}

void cmd_login_info(void) {
	char buf[256];
	sprintf(
		buf,
		"Account:%u Char:%u Login1:0x%08x Login2:0x%08x",
		chara.account_id,chara.chara_id,
		chara.login_id1,chara.login_id2
	);
	console_outputf("%s\n",buf);
	MessageBoxA(NULL,buf,"Login Info",MB_OK);
}

//  
// flag = 0 :  1: 
void cmd_sit(int flag) {
	char buf[256];
	PACKET *pk = &packet_db[packet_get("actionrequest")];
	memset(buf,0,pk->len);
	p2long(buf,pk->pos[0]) = 0;
	buf[pk->pos[1]] = flag ? 0x02 : 0x03;
	sock_send(pk->id,&buf,0);
	console_outputf("send: %s\n",flag ? "sit" : "stand");
	object[0].dead_sit = flag ? 2 : 0;
}

void cmd_say(HWND hWnd) {
	char buf[256];
	int  len;
	PACKET *pk;
	switch(SendDlgItemMessage(hWnd,IDC_SAY_MODE,CB_GETCURSEL,0,0)) {
	case 0:
		//   - S
		pk  = &packet_db[packet_get("globalmessage")];
		memset(buf,0,pk->pos[1]-2);
		len = sprintf(&buf[pk->pos[1]-2],"%s : ",object[0].chara_name);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[len + pk->pos[1] - 2],192);
		nobr(&buf[len + pk->pos[1] - 2]);
		if(buf[len + pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	case 1:
		//   - p[eB
		pk  = &packet_db[packet_get("partymessage")];
		memset(buf,0,pk->pos[1]-2);
		len = sprintf(&buf[pk->pos[1]-2],"%s : ",object[0].chara_name);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[len + pk->pos[1] - 2],192);
		nobr(&buf[len + pk->pos[1] - 2]);
		if(buf[len + pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	case 2:
		//  - Mh
		pk  = &packet_db[packet_get("guildmessage")];
		memset(buf,0,pk->pos[1]-2);
		len = sprintf(&buf[pk->pos[1]-2],"%s : ",object[0].chara_name);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[len + pk->pos[1] - 2],192);
		nobr(&buf[len + pk->pos[1] - 2]);
		if(buf[len + pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	case 3:
		// ł
		if(!mess_wis_body[0]) {
			// bZ[W𑗂Ăꍇ͑҂
			pk  = &packet_db[packet_get("wis")];
			memset(buf,0,pk->pos[2]-2);
			GetDlgItemTextA(hWnd,IDC_SAY_TARGET,&buf[pk->pos[1] - 2],192);
			nobr(&buf[pk->pos[1] - 2]);
			if(buf[pk->pos[1] - 2] != 0 && strlen(&buf[pk->pos[1] - 2]) <= 24) {
				// Target Name ݒ芮
				GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[pk->pos[2] - 2],192);
				nobr(&buf[pk->pos[2] - 2]);
				if(buf[pk->pos[2] - 2] != 0) {
					// {͊
					len = strlen(&buf[pk->pos[2] - 2]) + 1 + pk->pos[2] - 2;
					sock_send(pk->id,&buf,len);
					SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
					strcpy(mess_wis_name,&buf[pk->pos[1] - 2]); // eTƂ
					strcpy(mess_wis_body,&buf[pk->pos[2] - 2]); // eTƂ
				}
			}
		}
		break;
	case 4:
		//   - ŚiOtj
		pk  = &packet_db[packet_get("globalmessage")];
		memset(buf,0,pk->pos[1]-2);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[pk->pos[1] - 2],192);
		nobr(&buf[pk->pos[1] - 2]);
		if(buf[pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	case 5:
		//   - p[eBiOtj
		pk  = &packet_db[packet_get("partymessage")];
		memset(buf,0,pk->pos[1]-2);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[pk->pos[1] - 2],192);
		nobr(&buf[pk->pos[1] - 2]);
		if(buf[pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	case 6:
		//  - MhiOtj
		pk  = &packet_db[packet_get("guildmessage")];
		memset(buf,0,pk->pos[1]-2);
		GetDlgItemTextA(hWnd,IDC_SAY_BODY,&buf[pk->pos[1] - 2],192);
		nobr(&buf[pk->pos[1] - 2]);
		if(buf[pk->pos[1] - 2] != 0) {
			len = strlen(buf) + 1;
			sock_send(pk->id,&buf,len);
			SetDlgItemTextA(hWnd,IDC_SAY_BODY,"");
		}
		break;
	default:
		console_outputf("Say Target Not Supported.\n");
		break;
	}
}

