#ifndef _IO_FILE_H_
#define _IO_FILE_H_

void*          io_file_readall(const wchar_t* file,int *len);
int            io_file_writeall(const wchar_t* file,void *buf,int len);
int            io_file_size(const wchar_t* file);
const wchar_t* io_file_find(struct io_find *find);

struct io_file* io_file_readopen(const wchar_t *file);
int io_file_seek(struct io_file *file,int pos);
int io_file_tell(struct io_file *file);
int io_file_read(struct io_file *file,void *buf,int len);
int io_file_close(struct io_file *file);
int io_file_size2(struct io_file *file);

#endif /* _IO_FILE_H_ */
